define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var Model = function() {
		this.callParent();
	};

	Model.prototype.chartBtnClick = function(event) {
		this.showChart();
	};

	Model.prototype.chart2BtnClick = function(event) {
		this.chartBtnClick();
	};

	Model.prototype.showChart = function() {
		var process = this.comp("process");
		process.showChart("/rkyOA/ktgl/process/ktsq/ktsqProcess", this.comp("mainData").getCurrentRowID(), null);
	};

	Model.prototype.listTablesRowDblClick = function(event) {
		var tabs = this.comp("tabs");
		if (this.comp("mainData").getCurrentRow()) {
			tabs.setActiveTab("detailLi");
		}
	};

	Model.prototype.saveBtnClick = function(event) {
		debugger;
		var ktglData = this.comp('mainData');// 主表
		ktglData.p
		var firstDzData = this.comp('firstDzData');
		var secDzData = this.comp('secDzData');
		var thirdDzData = this.comp('thirdDzData');
		thirdDzData.setValue('F_DZYSSTATUS', 'YS');
		secDzData.setValue('F_DZYSSTATUS', 'YS');
		firstDzData.setValue('F_DZYSSTATUS', 'YS');
		var info = this.isCorrect();
		if (info != 'true') {
			this.ktsqShowError(info);
			return;
		}
		var row = ktglData.getCurrentRow();
		if (!row.val('F_SUBJECTLEADER1')) {
			row.val('F_SUBJECTLEADER1', '无');
		}
		if (!row.val('F_SUBJECTLEADER2')) {
			row.val('F_SUBJECTLEADER2', '无');
		}
		ktglData.saveData();
		this.comp("saveBtn").set({
			'disabled' : true
		});
	};

	Model.prototype.ktsqShowError = function(code) {
		sInfo = errorInfo[code].info;
		justep.Util.hint(sInfo, {
			type : 'success',
			parent : this.getRootNode(),
			position : 'top',
			delay : 5000
		});
	}

	var errorInfo = {
		"noYs" : {
			"info" : "预算为0，请填写各项预算"
		},
		"noFirDzys" : {
			"info" : "填写预算时必须填写第一次到账预算！"
		},
		"noDzys" : {
			"info" : "填写课题申请时必须填写第一次到账预算！"
		},
		"dzysBeyondYs" : {
			"info" : "到账预算总额超过预算总额，请仔细检查！"
		},
		"ylktYxcb" : {
			"info" : "院立课题的运行成本费用占总经费的85%，请仔细检查！"
		},
		"ylktKtjt" : {
			"info" : "院立课题的课题津贴费用占总经费的15%，请仔细检查！"
		},
		"sjktYxcb" : {
			"info" : "司局课题的运行成本费用占总经费的35%，请仔细检查！"
		},
		"sjktKtjt" : {
			"info" : "司局课题的课题津贴费用占总经费的35%，请仔细检查！"
		},
		"shzxktYxcb" : {
			"info" : "社会课题的运行成本费用占总经费的30%，请仔细检查！"
		},
		"shzxktKtjt" : {
			"info" : "社会课题的课题津贴费用占总经费的40%，请仔细检查！"
		},
		"ysNotEqualKzp" : {
			"info" : "预算总额与可支配金额不相等，请仔细检查！"
		},
		"dzClfBeyondYs" : {
			"info" : "到账预算差旅费用总和超过预算差旅费总额，请仔细检查！"
		},
		"dzHyfBeyondYs" : {
			"info" : "到账预算会议费用总和超过预算会议费总额，请仔细检查！"
		},
		"dzSjclfBeyondYs" : {
			"info" : "到账预算数据处理费用总和超过预算数据处理费总额，请仔细检查！"
		},
		"dzZlfBeyondYs" : {
			"info" : "到账预算资料费用总和超过预算资料费总额，请仔细检查！"
		},
		"dzYjfBeyondYs" : {
			"info" : "到账预算邮寄费用总和超过预算邮寄费总额，请仔细检查！"
		},
		"dzYsfBeyondYs" : {
			"info" : "到账预算印刷费用总和超过预算印刷费总额，请仔细检查！"
		},
		"dzQtBeyondYs" : {
			"info" : "到账预算其它费用总和超过预算其它费总额，请仔细检查！"
		},
		"dzYnbtBeyondYs" : {
			"info" : "到账预算科研绩效津贴费用总和超过预算科研绩效津贴费总额，请仔细检查！"
		},
		"dzZjzxfBeyondYs" : {
			"info" : "到账预算专家咨询费费用总和超过预算专家咨询费费总额，请仔细检查！"
		},
		"dzYwlwBeyondYs" : {
			"info" : "到账预算外聘人员劳务费费用总和超过预算外聘人员劳务费总额，请仔细检查！"
		},
		"noKtName" : {
			"info" : "课题名称为必填项，请填写！"
		},
		"noKtFunds" : {
			"info" : "课题经费为必填项，请填写！"
		},
		"noKtNum" : {
			"info" : "课题编号为必填项，请填写！"
		},
		"noKtlx" : {
			"info" : "课题类型为必填项，请填写！"
		},
		"noTwoKtlx" : {
			"info" : "二级课题类型为必填项，请填写！"
		},
		"noJfly" : {
			"info" : "经费来源为必填项，请填写！"
		},
		"noWtdw" : {
			"info" : "委托单位为必填项，请填写！"
		},
		"noOpenTime" : {
			"info" : "研究周期起始时间为必填项，请填写！"
		},
		"noFinishTime" : {
			"info" : "研究周期结束时间为必填项，请填写！"
		},
		"noKtMaster" : {
			"info" : "课题组长为必填项，请填写！"
		},
		"noCydw" : {
			"info" : "参与单位为必填项，请填写！"
		},
		"finishBigThanOpen" : {
			"info" : "研究周期中起始时间必须小于结束时间，请检查！！"
		},
		"systemBusiness" : {
			"info" : "预算填写不正确，请仔细检查！"
		},
		"noSubjectCode" : {
			"info" : "课题编号为必填项，请填写！"
		},
		"hyjhbIsNull" : {
			"info" : "会议计划表为空，请填写！"
		},
		"ktjtjhbIsNull" : {
			"info" : "课题津贴计划表为空，请填写！"
		},
		"dyjhbIsNull" : {
			"info" : "调研计划表为空，请填写！"
		},
		"noKtllr" : {
			"info" : "课题联络人为必填项，请填写！"
		}
	}

	function calcNum(str) {
		var num = 0.0;
		if (!str || isNaN(str)) {
			num = 0.0;
		} else {
			num = str;
		}
		return parseFloat(num);
	}

	Model.prototype.isCorrect = function(event) {
		var mainData = this.comp('mainData');
		var xmzys = this.comp('xmzysData');
		var ys = xmzys.getValue('F_HJ');
		var firDzys = this.comp('firstDzData');
		var secDzys = this.comp('secDzData');
		var thirdDzys = this.comp('thirdDzData');
		// 增加调研计划为必填项
		// 调研计划表为空
		var dyjhb = this.comp('dyjhb');
		var hyjhb = this.comp('hyjhb');
		var ktjtjhb = this.comp('ktjtjhb');

		// 判断，必填项是否已经填写
		var ktName = mainData.getValue('F_SUBJECTNAME');// 课题名称
		var subjectCode = mainData.getValue('F_SUBJECTCODE');// 课题编号
		var ktFunds = mainData.getValue('F_SUBJECTFUNDS');// 课题经费
		var ktNum = mainData.getValue('F_SUBJECTCODE');// 课题编号
		var ktlx = mainData.getValue('F_SUBJECTTYPE_BIG');// 一级课题类型
		var twoKtlx = mainData.getValue('F_SUBJECTTYPE');// 二级课题类型
		var jfly = mainData.getValue('F_FUNDSSOURCES');// 经费来源
		var wtdw = mainData.getValue('F_WTDW');// 委托单位
		var cydw = mainData.getValue('F_CYDW');// 参与单位
		var openTime = mainData.getValue('F_OPENINGTIME');// 起始周期
		var finishTime = mainData.getValue('F_POSTPROJECTTIME');// 结束周期
		var ktMaster = mainData.getValue('F_SUBJECTLEADER');// 课题组长
		var ktllr = mainData.getValue('F_KTLLR');// 课题联络人
		if (!ktName) {
			return 'noKtName';
		}
		if (!subjectCode) {
			return 'noSubjectCode';
		}
		/*
		 * if (!ktNum) { return 'noKtNum'; }
		 */
		if (!jfly) {
			return 'noJfly';
		}
		if (!ktFunds) {
			return 'noKtFunds';
		}
		if (!openTime) {
			return 'noOpenTime';
		}
		if (!finishTime) {
			return 'noFinishTime';
		}
		if (openTime >= finishTime) {
			return 'finishBigThanOpen';
		}
		if (!wtdw) {
			return 'noWtdw';
		}
		if (!ktlx) {
			return 'noKtlx';
		}
		if (!twoKtlx) {
			return 'noTwoKtlx';
		}
		if (!ktllr) {
			return 'noKtllr';
		}
		/*
		 * if (!cydw) { return 'noCydw'; }
		 */
		if (!ktMaster) {
			return 'noKtMaster';
		}

		// 判断，预算是否为0
		var ysHj = calcNum(xmzys.getValue('F_HJ'));
		if (ysHj == 0) {
			return 'noYs';
		}
		// 判断，根据课题类型判断运行成本及课题津贴的费用比例
		var kzp = calcNum(mainData.getValue('F_KZP'));
		var ktlx = mainData.getValue('F_SUBJECTTYPE');
		var yxcbhj = calcNum(xmzys.getValue('F_YXCBHJ'));
		var ktjthj = calcNum(xmzys.getValue('F_KTJTHJ'));
		var numKtFunds = calcNum(ktFunds);
		// 院立课题类型，运行成本费占总经费的80%，课题津贴占20%
		// 修改院立课题类型，运行成本费占总经费的85%，课题津贴占15%
		if ('院立课题' == ktlx) {
			if (yxcbhj != mul(numKtFunds, 0.85)) {
				return 'ylktYxcb';
			}
			if (ktjthj != mul(numKtFunds, 0.15)) {
				return 'ylktKtjt';
			}
		}
		// 司局课题类型，运行成本费占总经费的35%，课题津贴占35%
		if ('司局课题' == ktlx) {
			if (yxcbhj != mul(numKtFunds, 0.35)) {
				return 'sjktYxcb';
			}
			if (ktjthj != mul(numKtFunds, 0.35)) {
				return 'sjktKtjt';
			}
		}
		// 社会课题类型，运行成本费占总经费的30%，课题津贴占40%
		/*
		 * if ('社会课题' == ktlx) { if (yxcbhj != mul(numKtFunds, 0.3)) { return
		 * 'shzxktYxcb'; } if (ktjthj != mul(numKtFunds, 0.4)) { return
		 * 'shzxktKtjt'; } }
		 */
		// 判断，预算是否与可支配金额相等
		if (ysHj != kzp) {
			return 'ysNotEqualKzp';
		}
		// 判断，第一次到账预算是否为0
		var firDzysHj = calcNum(firDzys.getValue('F_FIRSTDZHJ'));
		var secDzysHj = calcNum(secDzys.getValue('F_SECDZHJ'));
		var thiDzysHj = calcNum(thirdDzys.getValue('F_THIRDDZHJ'));
		if (!firDzysHj && twoKtlx != "院立课题") {
			return 'noFirDzys';
		}
		// 判断，预算合计是否大于三次到账预算合计
		if (ysHj < firDzysHj + secDzysHj + thiDzysHj) {
			return 'dzysBeyondYs';
		}

		// 判断，单项预算是否大于三次到账预算单项费用合计
		// 差旅费
		var clf = calcNum(xmzys.getValue('F_CLF'));
		var firClf = calcNum(firDzys.getValue('F_CLF'));
		var secClf = calcNum(secDzys.getValue('F_CLF'));
		var thirdClf = calcNum(thirdDzys.getValue('F_CLF'));
		if (clf < firClf + secClf + thirdClf) {
			return 'dzClfBeyondYs';
		}
		// 会议费
		var hyf = calcNum(xmzys.getValue('F_HYF'));
		var firHyf = calcNum(firDzys.getValue('F_HYF'));
		var secHyf = calcNum(secDzys.getValue('F_HYF'));
		var thirdHyf = calcNum(thirdDzys.getValue('F_HYF'));
		if (hyf < firHyf + secHyf + thirdHyf) {
			return 'dzHyfBeyondYs';
		}
		// 数据处理费
		var cjclf = calcNum(xmzys.getValue('F_SJCLF'));
		var firCjclf = calcNum(firDzys.getValue('F_SJCLF'));
		var secCjclf = calcNum(secDzys.getValue('F_SJCLF'));
		var thirdCjclf = calcNum(thirdDzys.getValue('F_SJCLF'));
		if (cjclf < firCjclf + secCjclf + thirdCjclf) {
			return 'dzSjclfBeyondYs';
		}
		// 资料费
		var zlf = calcNum(xmzys.getValue('F_ZLF'));
		var firZlf = calcNum(firDzys.getValue('F_ZLF'));
		var secZlf = calcNum(secDzys.getValue('F_ZLF'));
		var thirdZlf = calcNum(thirdDzys.getValue('F_ZLF'));
		if (zlf < firZlf + secZlf + thirdZlf) {
			return 'dzZlfBeyondYs';
		}
		// 邮寄费
		var yjf = calcNum(xmzys.getValue('F_YJF'));
		var firYjf = calcNum(firDzys.getValue('F_YJF'));
		var secYjf = calcNum(secDzys.getValue('F_YJF'));
		var thirdYjf = calcNum(thirdDzys.getValue('F_YJF'));
		if (yjf < firYjf + secYjf + thirdYjf) {
			return 'dzYjfBeyondYs';
		}
		// 印刷费
		var ysf = calcNum(xmzys.getValue('F_YSF'));
		var firYsf = calcNum(firDzys.getValue('F_YSF'));
		var secYsf = calcNum(secDzys.getValue('F_YSF'));
		var thirdYsf = calcNum(thirdDzys.getValue('F_YSF'));
		if (ysf < firYsf + secYsf + thirdYsf) {
			return 'dzYsfBeyondYs';
		}
		// 其它费
		var qt = calcNum(xmzys.getValue('F_QT'));
		var firQt = calcNum(firDzys.getValue('F_QT'));
		var secQt = calcNum(secDzys.getValue('F_QT'));
		var thirdQt = calcNum(thirdDzys.getValue('F_QT'));
		if (qt < firQt + secQt + thirdQt) {
			return 'dzQtBeyondYs';
		}
		// 院内人员绩效津贴费
		var ynbt = calcNum(xmzys.getValue('F_YNBT'));
		var firYnbt = calcNum(firDzys.getValue('F_YNBT'));
		var secYnbt = calcNum(secDzys.getValue('F_YNBT'));
		var thirdYnbt = calcNum(thirdDzys.getValue('F_YNBT'));
		if (ynbt < firYnbt + secYnbt + thirdYnbt) {
			return 'dzYnbtBeyondYs';
		}
		// 专家咨询费
		var zjzx = calcNum(xmzys.getValue('F_ZJZX'));
		var firZjzx = calcNum(firDzys.getValue('F_ZJZX'));
		var secZjzx = calcNum(secDzys.getValue('F_ZJZX'));
		var thirdZjzx = calcNum(thirdDzys.getValue('F_ZJZX'));
		if (zjzx < firZjzx + secZjzx + thirdZjzx) {
			return 'dzZjzxfBeyondYs';
		}
		// 外聘人员劳务费
		var ywlw = calcNum(xmzys.getValue('F_YWLW'));
		var firYwlw = calcNum(firDzys.getValue('F_YWLW'));
		var secYwlw = calcNum(secDzys.getValue('F_YWLW'));
		var thirdYwlw = calcNum(thirdDzys.getValue('F_YWLW'));
		if (ywlw < firYwlw + secYwlw + thirdYwlw) {
			return 'dzYwlwBeyondYs';
		}
		// 调研计划表为空
		var temp = dyjhb.val('F_DYSJ');
		if (dyjhb.count() == 0 && twoKtlx != "院立课题") {
			return 'dyjhbIsNull';
		}
		// 会议计划表为空
		if (hyjhb.count() == 0 && twoKtlx != "院立课题") {
			return 'hyjhbIsNull';
		}
		// 课题津贴计划表为空
		if (ktjtjhb.count() == 0 && twoKtlx != "院立课题") {
			return 'ktjtjhbIsNull';
		}
		return 'true';

	}

	var add = function(a, b) {
		var c, d, e;
		try {
			c = a.toString().split(".")[1].length;
		} catch (f) {
			c = 0;
		}
		try {
			d = b.toString().split(".")[1].length;
		} catch (f) {
			d = 0;
		}
		return e = Math.pow(10, Math.max(c, d)), (mul(a, e) + mul(b, e)) / e;
	}

	var sub = function(a, b) {
		var c, d, e;
		try {
			c = a.toString().split(".")[1].length;
		} catch (f) {
			c = 0;
		}
		try {
			d = b.toString().split(".")[1].length;
		} catch (f) {
			d = 0;
		}
		return e = Math.pow(10, Math.max(c, d)), (mul(a, e) - mul(b, e)) / e;
	}

	var mul = function(a, b) {
		var c = 0, d = a.toString(), e = b.toString();
		try {
			c += d.split(".")[1].length;
		} catch (f) {
		}
		try {
			c += e.split(".")[1].length;
		} catch (f) {
		}
		return Number(d.replace(".", "")) * Number(e.replace(".", "")) / Math.pow(10, c);
	}

	var div = function(a, b) {
		var c, d, e = 0, f = 0;
		try {
			e = a.toString().split(".")[1].length;
		} catch (g) {
		}
		try {
			f = b.toString().split(".")[1].length;
		} catch (g) {
		}
		return c = Number(a.toString().replace(".", "")), d = Number(b.toString().replace(".", "")), mul(c / d, Math.pow(10, f - e));
	}

	Model.prototype.button9Click = function(event) {
		var ktzcyData = this.comp('ktzcyData');
		var options = {
			defaultValues : [ {
				'F_TYPE' : '课题组成员'
			} ]
		};
		ktzcyData.newData(options);

	};

	Model.prototype.button2Click = function(event) {
		var expertData = this.comp('expertData');
		var options = {
			defaultValues : [ {
				'F_TYPE' : '课题聘请专家'
			} ]
		};
		expertData.newData(options);
	};

	Model.prototype.button4Click = function(event) {
		var tempData = this.comp('tempData');
		var options = {
			defaultValues : [ {
				'F_TYPE' : '课题临时人员'
			} ]
		};
		tempData.newData(options);
	};

	Model.prototype.btnPrintClick = function(event) {
		var ctx = this.getContext();
		var process = ctx.getCurrentProcess();
		var activity = ctx.getCurrentActivity();
		var rowid = this.comp("mainData").getCurrentRowID(); //课题管理ID
		if (rowid && (rowid !== "")) {
			var url = "$UI/rkyOA/ktgl/process/ktsq/sendKtglActivity.w?process=" + process + "&activity=" + activity + "&rowid=" + rowid;
			justep.Portal.openWindow(url, {
				title : "课题打印单"
			});
		}
	};

	Model.prototype.isShow = function(event) {
	};

	Model.prototype.button15Click = function(event) {
		var dyjhb = this.comp('dyjhb');
		var options = {
			defaultValues : [ {
				'F_TYPE' : 'ktdy'
			} ]
		};
		dyjhb.newData(options);

	};

	Model.prototype.button7Click = function(event) {
		var hyjhb = this.comp('hyjhb');
		var options = {
			defaultValues : [ {
				'F_TYPE' : 'hyjh'
			} ]
		};
		hyjhb.newData(options);
	};

	Model.prototype.button11Click = function(event) {
		var ktjtjhb = this.comp('ktjtjhb');
		var options = {
			defaultValues : [ {
				'F_TYPE' : 'jtjh'
			} ]
		};
		ktjtjhb.newData(options);
	};

	Model.prototype.nextBtnClick = function(event) {
		var row = this.comp("mainData").next();
		this.comp("mainData").to(row);
	};

	Model.prototype.modelLoad = function(event) {
		var data = this.comp('mainData');
		var id = data.getCurrentRowID();
		var xmzysData = this.comp('xmzysData');
		var firstDzData = this.comp('firstDzData');
		var secDzData = this.comp('secDzData');
		var thirdDzData = this.comp('thirdDzData');
		xmzysData.setFilter('idFilter', "T_APP_XMZYS.F_KTGLID = '" + id + "'");
		firstDzData.setFilter('idFilter', "T_APP_XMZYS.F_KTGLID = '" + id + "'");
		secDzData.setFilter('idFilter', "T_APP_XMZYS.F_KTGLID = '" + id + "'");
		thirdDzData.setFilter('idFilter', "T_APP_XMZYS.F_KTGLID = '" + id + "'");
		xmzysData.refreshData();
		firstDzData.refreshData();
		secDzData.refreshData();
		thirdDzData.refreshData();
	};

	return Model;
});